{TWKIT.PAS TradeWars Utility Toolkit   Unit by Jeff Cabell.     }
{Written From: TWFiles Version Two, 2/8/1993 - by Jason M. Boyd }
{Special Thanks go to The Romulan Prince (real name unknown)    }
{Copyright (C) 1993 by Jeff Cabell.  All Rights Reserved.       }

unit TWKIT;
{==============================}  INTERFACE  {===============================}

{+==================================================+}
{| Info on how to locate records in specified files |}
{| Offset is listed next to the variables.          |}
{+==================================================+}
{** See Footnote References in TWKIT.DOC **}

{File: TWDATA.DAT                    }
  {General data : Location = Offset + 1}

  {Player Data Location = (Player# * 126) + Offset + 1}
  { 149 records for Player#, 2 to 150}

  {Sector Data Location = (Sector# * 126) + Offset + 19027}
  { 1000 Sector#, 1 to 1000}

  {Port data - location = (Port# * 126) + Offset + 145027}
  { 400 records for Port#, 1 to 400}

  {Planet data - location = (Planet# * 126) + Offset + 195427 }
  { 150 records for Planet#, 1 to 150}

{This is the Type Statement that Works for every record in the TWDATA.DAT  }
{File.  Whether it is planet record, User record, port record, or whatever.}
{I have renamed the variables for the various records for ease of use.     }
{Just declare the file to be TWDATA.DAT and everything else should work    }
{without any problems.  Just make sure to use the Location Formulas.       }
{    users = RECORD
               fa                   : string[42];
               FAREAL               : string[42];
               fb,fc,fd,fe,ff,fg    : INTEGER;
               fh,fi,fj,fk,fl,fm,fn : INTEGER;
               fo,fp,fq,fr,fs       : INTEGER;
               credits              : real;
             END;

    In record #0 fa is unused and FAREAL is the path to the GFILES area. In
    record #1 fa = Registration code, and FAREAL = underground password.}
uses crt;

type
  playerdata = record              { Offset }
    Game_name : string[42];          {  0}
    BBS_name  : string[42];          { 42}
    laston,                          { 84}
    killedby,                        { 86}
    Turns_left,                      { 88}
    Shields,                         { 90}
    Sector_loc,                      { 92}  {E}
    Fighters,                        { 94}
    Holds,                           { 96}
    Ore,                             { 98}
    Organics,                        {100}
    Equipment,                       {102}
    blown_up,                        {104}
    Corp,                            {106}
    Colonists,                       {108}
    Status,                          {110}  {O}
    Planet_on,                       {112}  {E}
    Last_sector,                     {114}
    experience,                      {116}
    alignment: Integer;              {118}
    credits: Real;                   {120}
  end;

  sectordata = record                          {Offset}
                 nebula : string[42];           {  0}  {B}
                 beacon : string[42];           { 42}  {B}
                {Destination sector of warp}
                 route_A,                       { 84}
                 route_B,                       { 86}
                 route_C,                       { 88}
                 route_D,                       { 90}
                 route_E,                       { 92}
                 route_F,                       { 94}
                 port,                          { 96}  {G}
                 a1,a2,a3,                      { 98}   {reserved bytes}
                 Fighters,                      {104}
                 mine_owner,                    {106}  {H}
                 Mines,                         {108}
                 fighter_owner,                 {110}  {H}
                 b1,b2,b3,                      {112}   {reserved bytes}
                 f_mode : integer;              {118}   {Fighter Mode: }
                                                        {0 = Defensive }
                                                        {1 = Toll      }
                                                        {2 = Offensive }
                 Tolls : real;                  {120}
               end;

  portdata = record                   { Offset }
               Portname : string[42];   {  0}    {B}
               lastship : string[42];   { 42}
               class,                   { 84}
               Last_visit,              { 86}    {I}
               orestorage,              { 88}
               orgstorage,              { 90}
               equstorage,              { 92}
               ore_prod,                { 94}
               org_prod,                { 96}
               equ_prod,                { 98}
               orePrice,                {100}    {F}  {These are the price}
               orgPrice,                {102}    {F}  {change factors for }
               equPrice,                {104}    {F}  {the TW  Commodities}
               a1,a2,                   {106}    {reserved bytes}
               portopenin,              {110}    {negative, days}
               b1,                      {112}    {reserved bytes}
               Time_last_visit,         {114}                 
               lastrob,                 {116}    {Last Robbed By Player #}
               c1    : integer;         {118}    {reserved bytes}
               credits : real;          {120}    {Accumulated Port Profits}
             end;

  planetdata = record                   {Offset}
                 Planet : string[42];    {  0}    {B}
                 creator : string[42];   { 42}    {B}
                 last_visited,           { 84}       {Date planet last visited}
                 ore_prod,               { 86}
                 org_prod,               { 88}       {Amount Produced Daily}
                 equ_prod,               { 90}
                 ore_amt,                { 92}
                 org_amt,                { 94}       {Amount On Planet}
                 equ_amt,                { 96}
                 mil_level,              { 98}       {%-age of fighter attack}
                 quasar_atmos,           {100}
                 quasar_sector,          {102}
                 planetclass,            {104}
                 last_time,              {106}       {Time planet last visited}
                 fighters,               {108}
                 citadel_level,          {110}       {Level + 1  ; 1 = no citadel}
                 planet_sect,            {112}
                 next_c_date,            {114}       {Date that next citadel}
                                                     {construction will be completed}
                 owner,                  {116}    {H}
                 p_shields : integer;    {118}       {# of planetary shields}
                 treasury : real;        {120}       {# of credits in treasury}
               end;

  twdata = record 
             reserved1 : string[42];                     {   0 }
             scoredir  : string[42];                     {  42 }
             TriCronChamp,                               {  84 }
             TriCronScore,                               {  86 }
             FerrengiHome,                               {  88 }
             StarDockLoc,                                {  90 }  {G}
             class_0_2,                                  {  92 }  {G}
             class_0_3,                                  {  94 }  {G}
             Ferrengi_Move,                              {  96 }  {C}
             Alien_Move,                                 {  98 }  {C}
{1.03d only} DesqViewCfg,                                { 100 }  {if not 1.03d, then unused}
             SysOpSec,                                   { 102 }
{1 or 0}     RealName,                                   { 104 } {allow alias?}
             reserved2,                                  { 106 }
{in seconds} PhotonWave,                                 { 108 }
{1 or 0}     Show_StarDock,                              { 110 }
             Maxships,                                   { 112 }
             reserved3,                                  { 114 }
             reserved4,					 { 116 }
             reserved5 : integer;                        { 118 }
             Jackpot  : real;                            { 120 }
           end;

{================= See how all the structures are the same ? ================}

{File: SHIPFILE.DAT                                           }
{Players' ship data - location = (Player# * 115) + Offset + 1 }
{149 records for Player#, 2-150                               }
  shipdata = record                     {Offset}
               shipname : string[46];    {  0}
               Date_mfg : string[31];    { 46}    {B}
               ported : integer;         { 77}
               a1    : integer;          { 79}        {reserved}
               shiptype : integer;       { 81}
               brandname : integer;      { 83}
               b1    : integer;          { 85}        {reserved}
               cloaks : integer;         { 87}
               Scanner: integer;         { 89}        {Type: 0 = None       }
                                                      {      1 = Density    }
                                                      {      2 = Holographic}
               genesis,                  { 91}
               mines,                    { 93}
               kills,                    { 95}
               beacons,                  { 97}
               photons,                  { 99}
               atomic_det,               {101}
               corbomite,                {103}
               E_probes,                 {105}
               disruptors,               {107}
               psychic,                  {109}
               planet_scanner,           {111}
               transfer_lock : integer;  {113}    {J}
             end;

{File: SHIPSTAT.DAT                                           }
{Ship Type Definition Location : (ShipType# * 45) + Offset + 1}
{  16 records for ShipType#, 0 to 15                          }

  shipstat = record                {Offset}
               Hold_Cost,           {  0}
               Drive_Cost,          {  2}
               Computer_Cost,       {  4}
               Hull_Cost,           {  6}
               MaxHolds,            {  8}
               InitHolds : integer; { 10}
               Move_mult : real;    { 12}   {D}
               MaxFighters,         { 18}
               MaxShields,          { 20}
               Odds,                { 22}        {multiplied by 10}
               MaxMines,            { 24}
               MaxBeacons,          { 26}
               MaxGenesis : integer;{ 28}
               Scanner,             { 30}
               TWarp,               { 31}
               PScanner : boolean;  { 32}        {Planet Scanner}
               a1,a2  : integer;    { 33}        {reserved bytes}
               MaxPhoton,           { 37}
               MaxAttack : integer; { 39}        {Max Fighters Per Attack}
               b1,b2 : integer;     { 41}        {reserved bytes}
             end;

{File: ALIENS.DAT                                     }
{Alien Data Location = (Alien# * 76) + Offset + 1     }
{  50 records for Alien#, 1-50                        }

  aliendata = record                      {Offset}
                alien_name : string[26];   {  0}   {B}
                shipname : string[26];     { 26}   {B}
                sector,                    { 52}
                ship_type,                 { 54}
                ship_mfgr,                 { 56}
                shields,                   { 58}
                fighters,                  { 60}
                holds,                     { 62}
                corbomite,                 { 64}
                experience,                { 66}
                alignment : integer;       { 68}
                credits : real;            { 70}
              end;

{File: FERRENGI.DAT                                         }
{Ferrengi Data Location : (Ferrengi# * 70) + Offset + 1     }
{  40 records for Ferrengi#, 1-40                           }

ferrengi_data = record
                  ferrengi_name : string[26]; {  0}   {B}
                  shipname : string[26];      { 26}   {B}
                  sector,                     { 52}
                  fighters,                   { 54}
                  shields,                    { 56}
                  corbomite,                  { 58}
                  dest_sect,                  { 60}   {N}
                  grudge1,                    { 62}   {H}  {Player #}
                  grudge2,                    { 64}   {H}  {Player #}
                  grudge3,                    { 66}   {H}  {Player #}
                  mode : integer;             { 68}   {N}
                end;

{File: TWCORP.DAT                                          }
{Corporation data - location: (Corp# * 110) + Offset + 111 }
{  50 records for Corp#, 1 to 50                           }

  corpdata = record                     {Offset}
               corpname : string[42];    {  0}    {B}
               ceo : string[42];         { 42}
               date_started : string[9]; { 84}    {B}
               password : string[9];     { 93}
               a1,a2,a3,
               a4,a5,a6 : byte;          {102}         {reserved bytes}
               kills :  integer;         {108}    {F}  {not used in game}
             end;


{File: TRADER.DAT                                                   }
{Tips from the grimy old trader Location: (Tip# * 195) + Offset + 1 }
{  Expandable records for Tip#, from 1 on up                        }

  grimytrader_data = record                   {Offset}
                       keyword1 : string[16];  {  0}
                       keyword2 : string[16];  { 16}
                       price : integer;        { 32}
                       tip_prob : integer;     { 34}    {M} {Probablility that this tip will be given}
                       a1 : byte;              { 36}
                       line1 : string[79];     { 37}    {B}
                       line2 : string[79];     {116}    {B}
                     end;

{File: FEDBOUNT.DAT                                              }
{Federation bounties - location = (FedBounty# * 14) + Offset + 1 }
{  Expandable records for FedBounty#, from 0 on up               }
{ Federation bounties are stored by individual bounty number.    }

  fedbounty_data = record                {Offset}
                     placed_by : integer;  { 0}
                     a1,a2 : byte;         { 2} {always 01 00}
                     placed_on : integer;  { 4}
                     claimed_by: integer;  { 6}
                     amount : real;        { 8}
                   end;

{File: CONTRACT.DAT
{Underground bounties - location = (Player# * 10) + Offset - 19  }
{ 149 records for Player#, 2 to 150                              }
{Underground bounties are stored by the player number on whom the}
{bounties are placed.                                            }

  contract_data = record              {Offset}
                    value : real;       { 0}
                    num_bounties,       { 6}
                    claimer : integer;  { 8}
                  end;


{File: GALABANK.DAT                                                      }
{Players' Galactic Bank accounts - location = (Player# * 6) + Offset - 5 }
{   149 records for Player#, 2-150                                       }

  bank_data = record           {Offset}
                credits : real;  { 0}    {K}   {Easy enough for you? <Grin>}
              end;

{File: TWSMF.DAT                                                }
{Player/game messages - location: (Message# * 186) + Offset + 1 }
{  Expandable records for Message#, from 0 on up                }

  message_data = record                     {Offset}
                   msgtext : string[161];    {  0}    {B}
                   msg_to : integer;         {161}          { -1 once read}
                   msg_from : integer;       {163}    {L}
                   time_sent : string[12];   {165}    {B}
                   date_sent : string[9];    {177}    {B}
                 end;

{File: WALLDAT.DAT                                                         }
{Graffiti on the Tavern bathroom wall - location: (Line# * 89) + Offset + 1}
{  Expandable records for Line#, from 0 on up                              }

  bathroom_data = record                     {Offset}
                    graffiti : string[80];     { 0}    {B}
                    date_written : string[9];  {80}    {B}
                  end;


const
  datafilename = 'TWDATA.DAT';
  shipfilename = 'SHIPFILE.DAT';
  shipstatfilename = 'SHIPSTAT.DAT';
  alienfilename = 'ALIENS.DAT';
  ferrengifilename = 'FERRENGI.DAT';
  corpfilename = 'TWCORP.DAT';
  grimyfilename = 'TRADER.DAT';
  bountyfilename = 'FEDBOUNT.DAT';
  contractfilename = 'CONTRACT.DAT';
  bankfilename = 'GALABANK.DAT';
  msgfilename = 'TWSMF.DAT';

var
  {**Record Declarations**}
  playerrec,
  portrec,
  planetrec,
  sectorrec,
  maindata : twdata;
  shiprec  : shipdata;  {No Pun Intended! <Grin>}
  statrec : shipstat;
  alienrec : aliendata;
  ferrengi : ferrengi_data;
  corp : corpdata;
  grimyrec: grimytrader_data;
  fedbounty : fedbounty_data;
  mafia_hit : contract_data;
  account : bank_data;
  msg : message_data;
  wall : bathroom_data;
  {**File Declarations**}
  datafile : file of twdata;
  shipfile : file of shipdata;
  shipstatfile : file of shipstat;
  alienfile : file of aliendata;
  ferrengifile : file of ferrengi_data;
  corpfile : file of corpdata;
  grimyfile : file of grimytrader_data;
  bountyfile : file of fedbounty_data;
  hit_file : file of contract_data;
  accountfile : file of bank_data;
  msgfile : file of message_data;
  bathroomfile : file of bathroom_data;

Procedure FindPlayer(playernum : integer);
Procedure FindSector(sectornum : integer);
Procedure FindPort(portnum : integer);
Procedure FindPlanet(planetnum : integer);
{=========================}  IMPLEMENTATION  {=============================}

Procedure FindPlayer (playernum : integer);
var
  f: file of playerdata;
  prec : playerdata;
begin
  assign(f,'TWDATA.DAT');
  reset(f);
  seek(f,((playernum * 126) + 1));
  with prec do read(f,prec);
end;


Procedure FindSector (sectornum : integer);
var
  f : file of sectordata;
  srec : sectordata;
begin
  assign (f,'TWDATA.DAT');
  reset(f);
  seek (f,((sectornum * 126) + 19027));
  with srec do read(f,srec);
end;

Procedure FindPort (portnum : integer);
  {Port data - location = (Port# * 126) + Offset + 145027}
  { 400 records for Port#, 1 to 400}
var
  f : file of portdata;
  prec : portdata;
begin
  assign (f,'TWDATA.DAT');
  reset(f);
  seek (f,((portnum * 126) + 145027));
  with prec do read(f,prec);
end;


Procedure FindPlanet(planetnum : integer);
{Planet data - location = (Planet# * 126) + Offset + 195427 }
{ 150 records for Planet#, 1 to 150}
var
  f : file of planetdata;
  prec : planetdata;
begin
  assign (f,'TWDATA.DAT');
  reset(f);
  seek (f,((planetnum * 126) + 195427));
  with prec do read(f,prec);
end;

begin
end.
{end of unit}
